<?php

namespace Drupal\html_title\Plugin\views\field;

use Drupal\views\Plugin\views\field\EntityField;

/**
 * A field that displays node html title.
 *
 * @ingroup views_field_handlers
 *
 * @ViewsField("node_html_title")
 */
class NodeHtmlTitle extends EntityField {

  /**
   * {@inheritdoc}
   */
  public function renderText($alter) {
    $filter = \Drupal::service('html_title.filter');
    $elements = $filter->getAllowHtmlTags();
    $tags = array_map(function ($element) {
      return '<' . $element . '>';
    }, $elements);

    if (!empty($this->options['settings']['link_to_entity'])) {
      $alter['make_link'] = TRUE;
      $alter['path'] = $alter['rendered']['#url']->toString();
    }

    $this->options['alter']['preserve_tags'] .= ' ' . implode(' ', $tags);
    $this->last_render = $filter->decodeToMarkup($this->last_render);

    return parent::renderText($alter);
  }

}
